##  Using RUNSTER Py template, version of 12/09/2016 :
##  rule written by pear.py ;
##  derived from training data : C:\op\cardiac_dat1.dat;
##  generated on creation date : Tue Sep 13 14:37:53 2016;
##  dumped on Tue Sep 13 19:33:22 2016.
##
beag_gold = 5.0 ** 0.5 * 0.5 + 0.5  ##  global

import  math  ##  math library called upon

##  helper functions :
def beag_bool (v):
	##  ensures same bool/math treatment as in Beagle :
	return  (v > 0) + 0

def beag_exor (v1,v2):
	##  exclusive or, as in Beagle :
	return  ((v1>0) != (v2>0))

def beag_root(v):
	##  safe square root :
	if v >= 0.0:
		return  math.sqrt(v)
	else:
		return  -math.sqrt(abs(v))

def beag_slog (v):
	##  safe natural logarithm :
	if v < 0:
		return -math.log1p(abs(v))
	else:
		return  math.log1p(v)

def runster_stabprep ():
	##  sets up fallout table :

	stab = {}
	stab['0'] = [1, 471, 146.05413640382775]

	##  unpacks stab lines.

	return (stab)
	##  stabprep ends.


def runster_regrule (vals,stab):
	##  input vals should be an object with appropriate attribute names.
	##  target : plasvol.
	##  rule mode is standard.

	bins = ['0','1']  ##  omit if demonic
	catlist = [207, 377.0, 471.0, 569.0, 867]
	priorvec = [77, 480.85714285714283, 146.05413640382775, 98]
	subrules = 1
	rule = [0] * 1
	##  compute rule values :
	rule[0] = max(min((3.0160556 * vals.yo),178),max(min((279.5399691 + vals.ci),(vals.ci + vals.circtime)),348.9125581))

	p = 0 ; b = []
	while (p < subrules):
		v = rule[p]  ##  omit if tabular
		b = ['0']  ##  omit if tabular
		p = p + 1  ##  early-r, late-py

	b = ''.join(b)  ##  should work in both modes
	##  standard :
	predval = v  ##  omit if tabular
	cellvals = priorvec  ##  omit if tabular
	cellsize = priorvec[0] ; standev = priorvec[2]  ##  omit if tabular
	smalldif = priorvec[3]  ## should work in both modes
	##  tabular :
	##  retrieve cell frequencies :

	return ([b,predval,standev,smalldif,cellsize])
##  regression rule ends.

##  should be loadable into berries.py .

##  ending.
